/* plugin-email-store.c generated by valac 0.48.14, the Vala compiler
 * generated from plugin-email-store.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include "geary-engine.h"
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#define PLUGIN_TYPE_EMAIL_STORE (plugin_email_store_get_type ())
#define PLUGIN_EMAIL_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_EMAIL_STORE, PluginEmailStore))
#define PLUGIN_IS_EMAIL_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_EMAIL_STORE))
#define PLUGIN_EMAIL_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_EMAIL_STORE, PluginEmailStoreIface))

typedef struct _PluginEmailStore PluginEmailStore;
typedef struct _PluginEmailStoreIface PluginEmailStoreIface;

#define PLUGIN_TYPE_EMAIL_IDENTIFIER (plugin_email_identifier_get_type ())
#define PLUGIN_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER, PluginEmailIdentifier))
#define PLUGIN_IS_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER))
#define PLUGIN_EMAIL_IDENTIFIER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER, PluginEmailIdentifierIface))

typedef struct _PluginEmailIdentifier PluginEmailIdentifier;
typedef struct _PluginEmailIdentifierIface PluginEmailIdentifierIface;

#define PLUGIN_TYPE_ACCOUNT (plugin_account_get_type ())
#define PLUGIN_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccount))
#define PLUGIN_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_ACCOUNT))
#define PLUGIN_ACCOUNT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccountIface))

typedef struct _PluginAccount PluginAccount;
typedef struct _PluginAccountIface PluginAccountIface;

#define PLUGIN_TYPE_EMAIL (plugin_email_get_type ())
#define PLUGIN_EMAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_EMAIL, PluginEmail))
#define PLUGIN_IS_EMAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_EMAIL))
#define PLUGIN_EMAIL_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_EMAIL, PluginEmailIface))

typedef struct _PluginEmail PluginEmail;
typedef struct _PluginEmailIface PluginEmailIface;
typedef enum  {
	PLUGIN_EMAIL_BODY_TYPE_PLAIN,
	PLUGIN_EMAIL_BODY_TYPE_HTML
} PluginEmailBodyType;

#define PLUGIN_EMAIL_TYPE_BODY_TYPE (plugin_email_body_type_get_type ())
enum  {
	PLUGIN_EMAIL_STORE_EMAIL_DISPLAYED_SIGNAL,
	PLUGIN_EMAIL_STORE_EMAIL_SENT_SIGNAL,
	PLUGIN_EMAIL_STORE_NUM_SIGNALS
};
static guint plugin_email_store_signals[PLUGIN_EMAIL_STORE_NUM_SIGNALS] = {0};

struct _PluginAccountIface {
	GTypeInterface parent_iface;
	const gchar* (*get_display_name) (PluginAccount* self);
};

struct _PluginEmailIdentifierIface {
	GTypeInterface parent_iface;
	PluginAccount* (*get_account) (PluginEmailIdentifier* self);
	GVariant* (*to_variant) (PluginEmailIdentifier* self);
};

struct _PluginEmailIface {
	GTypeInterface parent_iface;
	PluginEmailIdentifier* (*get_identifier) (PluginEmail* self);
	GearyEmailFlags* (*get_flags) (PluginEmail* self);
	GearyRFC822MailboxAddress* (*get_primary_originator) (PluginEmail* self);
	void (*load_body_as) (PluginEmail* self, PluginEmailBodyType type, gboolean convert, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar* (*load_body_as_finish) (PluginEmail* self, GAsyncResult* _res_, GError** error);
};

struct _PluginEmailStoreIface {
	GTypeInterface parent_iface;
	const GVariantType* (*get_email_identifier_variant_type) (PluginEmailStore* self);
	void (*get_email) (PluginEmailStore* self, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeCollection* (*get_email_finish) (PluginEmailStore* self, GAsyncResult* _res_, GError** error);
	PluginEmailIdentifier* (*get_email_identifier_for_variant) (PluginEmailStore* self, GVariant* id);
};

GType plugin_account_get_type (void) G_GNUC_CONST;
GType plugin_email_identifier_get_type (void) G_GNUC_CONST;
GType plugin_email_body_type_get_type (void) G_GNUC_CONST;
GType plugin_email_get_type (void) G_GNUC_CONST;
GType plugin_email_store_get_type (void) G_GNUC_CONST;
const GVariantType* plugin_email_store_get_email_identifier_variant_type (PluginEmailStore* self);
void plugin_email_store_get_email (PluginEmailStore* self,
                                   GeeCollection* ids,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
GeeCollection* plugin_email_store_get_email_finish (PluginEmailStore* self,
                                                    GAsyncResult* _res_,
                                                    GError** error);
PluginEmailIdentifier* plugin_email_store_get_email_identifier_for_variant (PluginEmailStore* self,
                                                                            GVariant* id);
static GType plugin_email_store_get_type_once (void);

const GVariantType*
plugin_email_store_get_email_identifier_variant_type (PluginEmailStore* self)
{
	g_return_val_if_fail (PLUGIN_IS_EMAIL_STORE (self), NULL);
	return PLUGIN_EMAIL_STORE_GET_INTERFACE (self)->get_email_identifier_variant_type (self);
}

void
plugin_email_store_get_email (PluginEmailStore* self,
                              GeeCollection* ids,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	PLUGIN_EMAIL_STORE_GET_INTERFACE (self)->get_email (self, ids, cancellable, _callback_, _user_data_);
}

GeeCollection*
plugin_email_store_get_email_finish (PluginEmailStore* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	return PLUGIN_EMAIL_STORE_GET_INTERFACE (self)->get_email_finish (self, _res_, error);
}

/**
     * Returns the email identifier specified by the given variant, if any.
     *
     * @see EmailIdentifier.to_variant
     * @see email_identifier_variant_type
     */
PluginEmailIdentifier*
plugin_email_store_get_email_identifier_for_variant (PluginEmailStore* self,
                                                     GVariant* id)
{
	g_return_val_if_fail (PLUGIN_IS_EMAIL_STORE (self), NULL);
	return PLUGIN_EMAIL_STORE_GET_INTERFACE (self)->get_email_identifier_for_variant (self, id);
}

static void
plugin_email_store_default_init (PluginEmailStoreIface * iface,
                                 gpointer iface_data)
{
	/**
	     * The type of variant email identifiers.
	     *
	     * @see EmailIdentifier.to_variant
	     * @see get_email_identifier_for_variant
	     */
	g_object_interface_install_property (iface, g_param_spec_boxed ("email-identifier-variant-type", "email-identifier-variant-type", "email-identifier-variant-type", G_TYPE_VARIANT_TYPE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** Emitted when an email has been displayed in the UI. */
	plugin_email_store_signals[PLUGIN_EMAIL_STORE_EMAIL_DISPLAYED_SIGNAL] = g_signal_new ("email-displayed", PLUGIN_TYPE_EMAIL_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, PLUGIN_TYPE_EMAIL);
	/** Emitted when an email has been sent. */
	plugin_email_store_signals[PLUGIN_EMAIL_STORE_EMAIL_SENT_SIGNAL] = g_signal_new ("email-sent", PLUGIN_TYPE_EMAIL_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, PLUGIN_TYPE_EMAIL);
}

/**
 * Provides plugins with access to email.
 *
 * Plugins that implement the {@link EmailExtension} interface may
 * obtain instances of this object by calling {@link
 * EmailContext.get_email_store} on their {@link EmailExtension.email}
 * property.
 */
static GType
plugin_email_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginEmailStoreIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_email_store_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType plugin_email_store_type_id;
	plugin_email_store_type_id = g_type_register_static (G_TYPE_INTERFACE, "PluginEmailStore", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (plugin_email_store_type_id, GEARY_TYPE_BASE_OBJECT);
	return plugin_email_store_type_id;
}

GType
plugin_email_store_get_type (void)
{
	static volatile gsize plugin_email_store_type_id__volatile = 0;
	if (g_once_init_enter (&plugin_email_store_type_id__volatile)) {
		GType plugin_email_store_type_id;
		plugin_email_store_type_id = plugin_email_store_get_type_once ();
		g_once_init_leave (&plugin_email_store_type_id__volatile, plugin_email_store_type_id);
	}
	return plugin_email_store_type_id__volatile;
}

